/* tas3.h  --  TAS3.eu API Implementation Using ZXID.org
 *
 * Copyright (c) 2009 Symlabs (symlabs@symlabs.com), All Rights Reserved.
 * Author: Sampo Kellomaki (sampo@iki.fi)
 * This is confidential unpublished proprietary source code of the author.
 * NO WARRANTY, not even implied warranties. Contains trade secrets.
 * Distribution prohibited unless authorized in writing.
 * Licensed under Apache License 2.0, see file COPYING.
 * $Id: zxidwsc.c,v 1.14 2009-08-30 15:09:26 sampo Exp $
 *
 * To use this API you will need to link against libzxid.a (-lzxid), libzxid.so,
 * or libzxid.dll Since the API implementation happens at compile time, the link
 * time symbols will be the zxid variants. If desired, the tas3 variants will be
 * provided in libtas3.a, .so, .dll, but this library is waiting for practical
 * demand before being supplied.
 *
 * See also: tas3-proto.pd for the official, but not exclusive, TAS3 API definition.
 *
 * 13.10.2009,  created --Sampo
 */

#ifndef _TAS3_H
#define _TAS3_H

#include <zxid.h>

/* Map ZXID functions to TAS3 equivalents */

#define tas3_new_conf_to_cf zxid_new_conf_to_cf
#define tas3_sso_cf        zxid_simple_cf
#define tas3_az            zxid_az
#define tas3_az_cf         zxid_az_cf
#define tas3_az_cf_ses     zxid_az_cf_ses
#define tas3_call          zxid_call
#define tas3_callf         zxid_callf
#define tas3_get_epr       zxid_get_epr
#define tas3_get_epr_url   zxid_get_epr_address
#define tas3_get_epr_entid zxid_get_epr_entid
#define tas3_get_epr_a7n   zxid_get_epr_a7n
#define tas3_epr2str       zxid_epr2str
#define tas3_wsp_validate  zxid_wsp_validate
#define tas3_wsp_decorate  zxid_wsp_decorate

#endif
